Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.beanutils
Class BeanPropertyValueEqualsPredicate

    java.lang.Object
      |
      +--org.apache.commons.beanutils.BeanPropertyValueEqualsPredicate

All Implemented Interfaces:
  org.apache.commons.collections.Predicate

public class BeanPropertyValueEqualsPredicate
extends java.lang.Object
implements org.apache.commons.collections.Predicate

`Predicate` that evaluates a property value against a specified value.

An implementation of `org.apache.commons.collections.Predicate` that evaluates a property value on the object provided against a specified value and returns `true` if equal; `false` otherwise. The `BeanPropertyValueEqualsPredicate` constructor takes two parameters which determine what property will be evaluated on the target object and what its expected value should be.

`

    public BeanPropertyValueEqualsPredicate( String propertyName, Object propertyValue )

`
  Will create a `Predicate` that will evaluate the target object and return `true` if the property specified by `propertyName` has a value which is equal to the the value specified by `propertyValue`. Or return `false` otherwise.

Note: Property names can be a simple, nested, indexed, or mapped property as defined by `org.apache.commons.beanutils.PropertyUtils`. If any object in the property path specified by `propertyName` is `null` then the outcome is based on the value of the `ignoreNull` attribute.

A typical usage might look like: ``

     // create the closure
     BeanPropertyValueEqualsPredicate predicate =
        new BeanPropertyValueEqualsPredicate( "activeEmployee", Boolean.FALSE );

     // filter the Collection
     CollectionUtils.filter( peopleCollection, predicate );

This would take a `Collection` of person objects and filter out any people whose `activeEmployee` property is `false`. Assuming...

- The top level object in the `peeopleCollection` is an object which represents a person.
- The person object has a `getActiveEmployee()` method which returns the boolean value for the object's `activeEmployee` property.

Another typical usage might look like: ``

     // create the closure
     BeanPropertyValueEqualsPredicate predicate =
        new BeanPropertyValueEqualsPredicate( "personId", "456-12-1234" );

     // search the Collection
     CollectionUtils.find( peopleCollection, predicate );

`

This would search a `Collection` of person objects and return the first object whose `personId` property value equals `456-12-1234`. Assuming...

- The top level object in the `peeopleCollection` is an object which represents a person.
- The person object has a `getPersonId()` method which returns the value for the object's `personId` property.

Author:
  Norm Deane
See Also:
  `PropertyUtils`, `Predicate`

Constructor Summary
`BeanPropertyValueEqualsPredicate(java.lang.String propertyName, java.lang.Object propertyValue)` Constructor which takes the name of the property, its expected value to be used in evaluation, and assumes `ignoreNull` to be `false`.
`BeanPropertyValueEqualsPredicate(java.lang.String propertyName, java.lang.Object propertyValue, boolean ignoreNull)` Constructor which takes the name of the property, its expected value to be used in evaluation, and a boolean which determines whether `null` objects in the property path will genenerate an `IllegalArgumentException` or not.

Method Summary
`boolean` | `evaluate(java.lang.Object object)` Evaulates the object provided against the criteria specified when this `BeanPropertyValueEqualsPredicate` was constructed.
`java.lang.String` | `getPropertyName()` Returns the name of the property which will be evaluated when this `Predicate` is executed.
`java.lang.Object` | `getPropertyValue()` Returns the value that the property specified by `propertyName` will be compared to when this `Predicate` executes.
`boolean` | `isIgnoreNull()` Returns the flag which determines whether `null` objects in the property path will genenerate an `IllegalArgumentException` or not.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BeanPropertyValueEqualsPredicate

    public BeanPropertyValueEqualsPredicate(java.lang.String propertyName,
                                            java.lang.Object propertyValue)

  Constructor which takes the name of the property, its expected value to be used in evaluation, and assumes `ignoreNull` to be `false`.
  Parameters:
    `propertyName` - The name of the property that will be evaluated against the expected value.
    `propertyValue` - The value to use in object evaluation.
  Throws:
    `java.lang.IllegalArgumentException` - If the property name provided is null or empty.

### BeanPropertyValueEqualsPredicate

    public BeanPropertyValueEqualsPredicate(java.lang.String propertyName,
                                            java.lang.Object propertyValue,
                                            boolean ignoreNull)

  Constructor which takes the name of the property, its expected value to be used in evaluation, and a boolean which determines whether `null` objects in the property path will genenerate an `IllegalArgumentException` or not.
  Parameters:
    `propertyName` - The name of the property that will be evaluated against the expected value.
    `propertyValue` - The value to use in object evaluation.
    `ignoreNull` - Determines whether `null` objects in the property path will genenerate an `IllegalArgumentException` or not.
  Throws:
    `java.lang.IllegalArgumentException` - If the property name provided is null or empty.

Method Detail

### evaluate

    public boolean evaluate(java.lang.Object object)

  Evaulates the object provided against the criteria specified when this `BeanPropertyValueEqualsPredicate` was constructed. Equality is based on either reference or logical equality as defined by the property object's equals method. If any object in the property path leading up to the target property is `null` then the outcome will be based on the value of the `ignoreNull` attribute. By default, `ignoreNull` is `false` and would result in an `IllegalArgumentException` if an object in the property path leading up to the target property is `null`.
  Specified by:
    `evaluate` in interface `org.apache.commons.collections.Predicate`
  Parameters:
    `object` - The object to be evaluated.
  Returns:
    True if the object provided meets all the criteria for this `Predicate`; false otherwise.
  Throws:
    `java.lang.IllegalArgumentException` - If an IllegalAccessException, InvocationTargetException, or NoSuchMethodException is thrown when trying to access the property specified on the object provided. Or if an object in the property path provided is `null` and `ignoreNull` is set to `false`.

### getPropertyName

    public java.lang.String getPropertyName()

  Returns the name of the property which will be evaluated when this `Predicate` is executed.
  Returns:
    The name of the property which will be evaluated when this `Predicate` is executed.

### getPropertyValue

    public java.lang.Object getPropertyValue()

  Returns the value that the property specified by `propertyName` will be compared to when this `Predicate` executes.
  Returns:
    The value that the property specified by `propertyName` will be compared to when this `Predicate` executes.

### isIgnoreNull

    public boolean isIgnoreNull()

  Returns the flag which determines whether `null` objects in the property path will genenerate an `IllegalArgumentException` or not. If set to `true` then if any objects in the property path evaluate to `null` then the `IllegalArgumentException` throw by `PropertyUtils` will be logged but not rethrown and `false` will be returned. If set to `false` then if any objects in the property path evaluate to `null` then the `IllegalArgumentException` throw by `PropertyUtils` will be logged and rethrown.
  Returns:
    The flag which determines whether `null` objects in the property path will genenerate an `IllegalArgumentException` or not.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 The Apache Software Foundation. All Rights Reserved.`